/****************************************************************************
**
** This file is part of PLCEdit, an open-source cross-platform editor 
** for PLC source files (e.g. from Moeller, CoDeSys and Siemens).
** Copyright (C) 2005-2009  M. Rehfeldt
**
** This software uses classes of Trolltech Qt toolkit and is freeware. 
** This file may be used under the terms of the GNU General Public License 
** version 2.0 or (at your option) any later version as published by the 
** Free Software Foundation and appearing in the file LICENSE.GPL included 
** in the packaging of this file. 
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** Contact e-mail: M. Rehfeldt <info@plcedit.org>
** Program URL   : http://www.plcedit.org
**
****************************************************************************/
	

#ifndef SINGLEAPPWIN_H
#define SINGLEAPPWIN_H


#include <QApplication>

#ifdef Q_WS_WIN

class SingleAppWin;

#define singleApp (static_cast<SingleAppWin *>(QApplication::instance()))


class SingleAppWin : public QApplication
{
	Q_OBJECT

public:
	SingleAppWin( int &argc, char *argv[], const QString uniqueId );
	virtual ~SingleAppWin();


	bool isPrevInstance() const;
	bool sendMessageToPrevInstance( const QString windowTitle, const QString message ) const;
	bool bringPrevInstanceToFront( const QString windowTitle ) const;
	virtual bool winEventFilter( MSG *msg, long *result );

		
private:
	void *m_mutex;		//!< member variable mutex
	bool m_prevInstance;//!< memeber variable previous instance
	

signals:
	void messageReceived( QString message );
		
};
#endif
#endif
